︠ef1b9678-9d9d-4381-ba41-67cae47f58ad︠
##############################################
# Problem 0 - Euclidean Algorithm
##############################################
︡1d448a2a-692c-4771-aeba-21cd534a313e︡{"done":true}
︠37f2d25e-fb75-4640-af91-f94cb22b8fdcs︠
def gcd_ea(a,b):
    """
    This function returns the Greatest Common Divisor of a and b.
    """
    x = abs(a)
    y = abs(b)
    while (y != 0): #Can speed things up using y != 0 vs y > 0
        # print (x,y)
        r = mod(x,y) #Is faster faster with x%y
        x = y
        y = r
    return x #Return gcd(a,b)
︡1b0f6bf4-d096-4352-a1a9-4e2828aab070︡{"done":true}
︠1b0d5071-285a-4ac5-a788-c43ff75ced0b︠
import time
︡d941b904-94d6-4acd-a0d0-859776146283︡{"done":true}
︠bdb1f7b2-2bd2-454b-8f7b-330526400a8es︠
t = time.time() #Start Time
gcd_ea(8675309,3892394)
dt = time.time() - t #Difference in Time = End Time - Start Time
print dt
︡53484e7a-2d59-41a9-84b9-d57fb0936f15︡{"stdout":"1\n"}︡{"stdout":"0.000687837600708\n"}︡{"done":true}
︠4e15a6cf-6709-4dac-943f-28b592b34ebas︠
t = time.time() #Start Time
gcd_ea(31313,519)
dt = time.time() - t #Difference in Time = End Time - Start Time
print dt
︡ba44040e-6976-40ee-9aa6-477c14cea14a︡{"stdout":"173\n"}︡{"stdout":"0.00163507461548\n"}︡{"done":true}
︠22860ac5-b7f6-4fb4-af14-4d3180dbac53︠
##############################################
# Problem 1.c - Extended Euclidean Algorithm
##############################################
︡93862c35-5828-4124-bb19-275f88cca735︡{"done":true}
︠3d3b0727-e295-487b-ab30-1639ce446a86s︠
def gcd_eea(a,b):
    u = 1
    g = a
    y = b
    x = 0
    while (y != 0):
        q = g//y #Faster with g//y vs floor(g/y)
        t = g%y #Is faster faster with %
        s = u - q*x
        u = x
        g = y
        x = s
        y = t
    v = (g - a*u)/b
    return (g,u,v)
︡09edb49f-7fd4-407f-a083-48fe116f4900︡{"done":true}
︠cd04f027-2f56-4433-8f29-33ef545658a9s︠
gcd_eea(31313,519)
gcd_eea(167181,163961)
gcd_eea(8675309,3892394)
︡4b6a3cc1-f3a0-4763-8053-a2727320ce28︡{"stdout":"(173, 1, -60)\n"}︡{"stdout":"(7, -4430, 4517)\n"}︡{"stdout":"(1, -843845, 1880749)\n"}︡{"done":true}
︠9b0d4e46-16b4-47d1-b9c5-3a2ae1c3220ds︠
import time
︡b9b9e135-442a-407e-9b80-8e9aa691078f︡{"done":true}
︠0e797292-09e9-41d5-ab25-d886bb9d8b79s︠
t = time.time()
gcd_eea(8675309,3892394)
dt = time.time() - t
dt
︡ce7f328a-1d38-4579-9647-2570ece651a6︡{"stdout":"(1, -843845, 1880749)\n"}︡{"stdout":"0.00080108642578125\n"}︡{"done":true}
︠c16c52d1-2cd8-4382-b651-eb86072b03fbs︠
︡c842b1de-6d99-4897-bf29-a5119c2fa913︡{"done":true}
︠668b110a-6727-41a5-a9ff-d1c2d02a651b︠

##############################################
# Problem 1.d - Extended Euclidean Algorithm
##############################################
︡ef68ee0f-c2fa-4ce4-a7ba-e31e8d4166ad︡{"done":true}
︠f1323bd1-8db4-4993-811b-6673ed749b30s︠
def gcd_eea_posu(a,b):
    u = 1
    g = a
    y = b
    x = 0
    while (y != 0):
        q = floor(g/y)
        #q = g//y #Faster with g//y vs floor(g/y)
        t = g%y #Is faster faster with %
        s = u - q*x
        u = x
        g = y
        x = s
        y = t
    v = (g - a*u)/b
    while (u < 0):
        u = u + b/g
        v = v - a/g
    return (g,u,v)
︡dc87f185-5294-4dfe-859e-a2751f3df53c︡{"done":true}
︠f2cfe7ea-d7ea-4a1c-9348-eb1f922963f8s︠
t = time.time()
gcd_eea_posu(8675309,3892394)
dt = time.time() - t
dt
︡757fe805-c4b2-453d-8252-05706c7d9643︡{"stdout":"(1, 3048549, -6794560)\n"}︡{"stdout":"0.0007898807525634766\n"}︡{"done":true}
︠db0664f9-9717-4136-8fed-712d3cb24274s︠
gcd_eea_posu(31313,519)
gcd_eea_posu(167181,163961)
gcd_eea_posu(8675309,3892394)
︡86ca8835-2fdf-4ce6-a4b9-a7dc133c4cdb︡{"stdout":"(173, 1, -60)\n"}︡{"stdout":"(7, 18993, -19366)\n"}︡{"stdout":"(1, 3048549, -6794560)\n"}︡{"done":true}
︠963250dd-93dd-4c94-a96b-83cf7337b3dc︠









